'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var react = require('react');

/* istanbul ignore next */
/** keep typescript happy */
var noop = function () { };
function useInterval(callback, delay, immediate) {
    var savedCallback = react.useRef(noop);
    // Remember the latest callback.
    react.useEffect(function () {
        savedCallback.current = callback;
    });
    // Execute callback if immediate is set.
    react.useEffect(function () {
        if (!immediate)
            return;
        if (delay === null || delay === false)
            return;
        savedCallback.current();
    }, [immediate]);
    // Set up the interval.
    react.useEffect(function () {
        if (delay === null || delay === false)
            return undefined;
        var tick = function () { return savedCallback.current(); };
        var id = setInterval(tick, delay);
        return function () { return clearInterval(id); };
    }, [delay]);
}

exports.useInterval = useInterval;
exports.default = useInterval;
//# sourceMappingURL=index.js.map
